gpio = require("GPIO")
dss = require("dss")
copas = require("copas")

gpio.setmode(gpio.BOARD)
btn, led1, led2 = 12, 11, 13

gpio.setup(btn, gpio.IN, gpio.PUD_DOWN)
gpio.setup(led1, gpio.OUT)
gpio.setup(led2, gpio.OUT)

cnt=0
gpio.output(led1, 1)

cb_btn_press = function(channel)
   cnt = cnt + 1
   if cnt == 10 then
     print ("Finished")
     gpio.output(led1, 0)
     gpio.output(led2, 0)
     gpio.cleanup()	
     os.exit()
   end
   gpio.output(led1, 0)
   gpio.output(led2, 1)
   led1, led2 = led2, led1
end

gpio.add_event_detect(btn, gpio.RISING, cb_btn_press, 200)

-- install the DSS socket receiver/handler that will 
-- do the hard work and make sure our callbacks are called
copas.addserver(
   dss.getsocket(), function(skt)
     skt = copas.wrap(skt)
     local hdlr = dss.gethandler()
     while true do
       hdlr(skt)
     end
   end)

copas.loop()  -- will never return

