gpio = require("GPIO")

BUZZER_OUT=18
LED_OUT=25

local sleep = function(seconds)
  os.execute("sleep "..tostring(seconds).."s")
end

gpio.setmode(gpio.BCM)
gpio.setup(BUZZER_OUT, gpio.OUT)
gpio.setup(LED_OUT, gpio.OUT)

-- SW-PWM instabil ab 500 Hz
dimmer = gpio.newPWM(LED_OUT, 100)  -- Hertz  
dimmer:start(0)                 -- duty cycle off

for cycle =100, 0, -1 do      
    dimmer:ChangeDutyCycle(cycle)
    sleep(0.04)
end

buzzer = gpio.newPWM(BUZZER_OUT, 5)  -- Hertz  
buzzer:start(0)                 -- duty cycle off

for cycle =100, 0, -10 do      
    buzzer:ChangeDutyCycle(cycle)
    sleep(0.5)
    print(cycle)
end
gpio.output(BUZZER_OUT, 0)

buzzer:stop()
dimmer:stop()

gpio.cleanup()