GPIO=require "GPIO"

btnExit = 21
buttons = {7, 15, 13, 11, btnExit}
leds = {12, 16, 18, 26}

GPIO.setmode(GPIO.BOARD)
GPIO.setwarnings(False)
math.randomseed(os.time())

for k,v in pairs(buttons) do
  GPIO.setup(v, GPIO.IN,  GPIO.PUD_DOWN)
end

for k,v in pairs(leds) do
  GPIO.setup(v, GPIO.OUT)
end

flashLED = function (cycles) 
  for x=1, cycles*2 do
    for k,v in pairs(leds) do 
      GPIO.output(v, x%2); 
    end
    os.execute("sleep 0.2")
  end
end

beep = function(num, wait)
  GPIO.output(leds[num], 1)
  os.execute("ogg123 --quiet -K1 beep"..num..".ogg")
  GPIO.output(leds[num], 0)
  if wait==true then os.execute("sleep 0.1") end
end

flashLED(3)

playlist = {}

while true do
  
  playlist[#playlist+1] = math.random(#leds)
  
  for k,v in pairs (playlist) do
    beep(v, true)
  end
  
  for k,v in pairs (playlist) do
    waitForUser=true
    while waitForUser do
      
      for kb,vb in pairs(buttons) do 
        if GPIO.input(vb) == true then
          if (vb~=buttons[v]) then 
            if vb~=btnExit then os.execute("ogg123 --quiet gameover.ogg") end
            GPIO.cleanup()
            os.exit()
          else 
            beep(v, false)
          end
          waitForUser=false
        end
      end
    end
  end
  
  flashLED(1) 
end