GPIO = require("GPIO")

pin_rs = 22               -- register select pin
pin_e  = 18               -- enable pin
pin_db = {16, 11, 13, 15} -- data pins 1,2,3,4

hd44780 = require("module.lcd-hd44780")
GPIO.setmode(GPIO.BOARD)
lcd = hd44780.initialize(pin_rs, pin_e, pin_db)
lcd:begin(8,2)

lcd:clear()

--lcd:blink() --blinking cursor
lcd:message("LCD TEST\n12345678")
hd44780.delayMicroseconds(10000 * 500)

scroll1="Say hello to a scrolling text"

lcd:clear()
lcd:message(scroll1)
for j=0, #scroll1 do
  lcd:scrollDisplayLeft()
  hd44780.delayMicroseconds(1000 * 250)
end
lcd:clear()

lcd:message(scroll1)
for j=0, #scroll1 do
  lcd:scrollDisplayRight()
  hd44780.delayMicroseconds(1000 * 250)
end

lcd:clear()

lcd:setCursor(3,1)
lcd:message( "XX"  )
 
hd44780.delayMicroseconds(10000 * 500)
lcd:clear()